commit c5bf6dc27cdb091f1f8046f98ce7ca197bffd908
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Wed Jan 12 21:24:49 2022

    Fortran: fix error recovery on bad structure constructor in DATA statement
    
    gcc/fortran/ChangeLog:
    
            PR fortran/67804
            * primary.c (gfc_match_structure_constructor): Recover from errors
            that occurred while checking for a valid structure constructor in
            a DATA statement.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/67804
            * gfortran.dg/pr93604.f90: Adjust to changed diagnostics.
            * gfortran.dg/pr67804.f90: New test.
    
    (cherry picked from commit 0b8464365b15ac108cd1d00d5bc56d229c1340de)

diff --git a/gcc/fortran/primary.c b/gcc/fortran/primary.c
index 44ba4d22ef6..1b93f96367f 100644
--- a/gcc/fortran/primary.c
+++ b/gcc/fortran/primary.c
@@ -3355,6 +3355,7 @@ gfc_match_structure_constructor (gfc_symbol *sym, gfc_expr **result)
   match m;
   gfc_expr *e;
   gfc_symtree *symtree;
+  bool t = true;
 
   gfc_get_ha_sym_tree (sym->name, &symtree);
 
@@ -3385,10 +3386,18 @@ gfc_match_structure_constructor (gfc_symbol *sym, gfc_expr **result)
      in the structure constructor must be a constant.  Try to reduce the
      expression here.  */
   if (gfc_in_match_data ())
-    gfc_reduce_init_expr (e);
+    t = gfc_reduce_init_expr (e);
 
-  *result = e;
-  return MATCH_YES;
+  if (t)
+    {
+      *result = e;
+      return MATCH_YES;
+    }
+  else
+    {
+      gfc_free_expr (e);
+      return MATCH_ERROR;
+    }
 }
 
 
diff --git a/gcc/testsuite/gfortran.dg/pr67804.f90 b/gcc/testsuite/gfortran.dg/pr67804.f90
new file mode 100644
index 00000000000..e2009a5bfdb
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr67804.f90
@@ -0,0 +1,25 @@
+! { dg-do compile }
+! PR fortran/67804 - ICE on bad type in structure constructor in DATA statement
+! Contributed by G.Steinmetz
+
+program p
+  type t
+     character :: c
+  end type
+  type u
+     character, pointer :: c
+  end type
+  type(t) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9
+  type(u) :: y6
+  data x0 /t('a')/     ! OK
+  data x1 /t(1)/       ! { dg-error "Cannot convert" }
+  data x2 /t(1.)/      ! { dg-error "Cannot convert" }
+  data x3 /t(1d1)/     ! { dg-error "Cannot convert" }
+  data x4 /t((0.,1.))/ ! { dg-error "Cannot convert" }
+  data x5 /t(.true.)/  ! { dg-error "Cannot convert" }
+  data x6 /t(null())/  ! { dg-error "neither a POINTER nor ALLOCATABLE" }
+  data x7 /t(['1'])/   ! { dg-error "The rank of the element" }
+  data x8 /t([1])/     ! { dg-error "Cannot convert" }
+  data x9 /t(z'0')/    ! { dg-error "Cannot convert" }
+  data y6 /u(null())/  ! OK
+end
diff --git a/gcc/testsuite/gfortran.dg/pr93604.f90 b/gcc/testsuite/gfortran.dg/pr93604.f90
index 2c695d37829..4040155120c 100644
--- a/gcc/testsuite/gfortran.dg/pr93604.f90
+++ b/gcc/testsuite/gfortran.dg/pr93604.f90
@@ -5,6 +5,6 @@ program p
       integer :: a
    end type
    type(t) :: x
-   data x /t(z'1')/ ! { dg-error "cannot appear in a structure constructor" }
+   data x /t(z'1')/ ! { dg-error "BOZ" }
 end
 

